/* $Id: kbhit.c,v 1.2 1996/04/25 19:10:48 quade Exp quade $ */

#include <stdio.h>
#include <sys/time.h>
#include <sys/types.h>
#include <termios.h>
#include <unistd.h>

int kbhit(void)
{
    fd_set rfds;
    struct timeval tv;
    int retval;
    struct termios term, oterm;
    int fd = 0;

    tcgetattr( fd, &oterm );
    memcpy( &term, &oterm, sizeof(term) );
    cfmakeraw(&term);
    tcsetattr( fd, TCSANOW, &term );

    /* Watch stdin (fd 0) to see when it has input. */
    FD_ZERO(&rfds);
    FD_SET(0, &rfds);
    /* Wait up to tv_sec seconds. */
    tv.tv_sec = 0;
    tv.tv_usec = 0;

    retval = select(1, &rfds, NULL, NULL, &tv);
    /* Don't rely on the value of tv now! */

    tcsetattr( fd, TCSANOW, &oterm );
    return(retval);
}

char mygetch(void)
{
	int c, fd=0;
	struct termios term, oterm;

	tcgetattr( fd, &oterm );
	memcpy( &term, &oterm, sizeof(term) );
	cfmakeraw(&term);
	tcsetattr( fd, TCSANOW, &term );
	c=getchar();
	tcsetattr( fd, TCSANOW, &oterm );
	return( (char)c );
}
